// Cube Primitive for VModel & WinOSi
// ----------------------------------
// 09.06.1999           Michael Granz

#include "general.h"
#include "Primitives.h"


/*float IntFace(vector Org, vector Ray, int algn)
{
  vector B,N;
  switch(algn){
    case 0: B=vector( 0.5f,  0.5f,  0.5f); N=vector( 1.0f,  0.0f,  0.0f); break;
    case 1: B=vector( 0.5f,  0.5f,  0.5f); N=vector( 0.0f,  1.0f,  0.0f); break;
    case 2: B=vector( 0.5f,  0.5f,  0.5f); N=vector( 0.0f,  0.0f,  1.0f); break;
    case 3: B=vector(-0.5f, -0.5f, -0.5f); N=vector(-1.0f,  0.0f,  0.0f); break;
    case 4: B=vector(-0.5f, -0.5f, -0.5f); N=vector( 0.0f, -1.0f,  0.0f); break;
    case 5: B=vector(-0.5f, -0.5f, -0.5f); N=vector( 0.0f,  0.0f, -1.0f); break;
  }
  if((Ray%N)==0.0f) return -1.0f;
  double t = ((B-Org)%N)/(Ray%N); if(t<=0.0) return -1.0f;
  vector iP = Org+(float)t*Ray;
  switch(algn){
    case 0:
    case 3: return ((iP.y>=-0.5f) && (iP.y<=0.5f) && (iP.z>=-0.5f) && (iP.z<=0.5f))? (float)t : -1.0f; break;
    case 1: 
    case 4: return ((iP.x>=-0.5f) && (iP.x<=0.5f) && (iP.z>=-0.5f) && (iP.z<=0.5f))? (float)t : -1.0f; break;
    case 2:
    case 5: return ((iP.x>=-0.5f) && (iP.x<=0.5f) && (iP.y>=-0.5f) && (iP.y<=0.5f))? (float)t : -1.0f; break;
  }
  return -1.0f;
}*/

// Parsing ---------------------------------------------------------

int Cube::ParseToken(char *a, CFile *file) { return 1; }

// Intersection ----------------------------------------------------

/*float Cube::Intersect(vector Org, vector Ray)
{
  Ray=Ray*Tb-vector(Tb.M41, Tb.M42, Tb.M43);
  Org=Org*Tb;
  float t, t1, t2=-1.0f;
  t1 = IntFace(Org, Ray, 0);
  t  = IntFace(Org, Ray, 1); if(t>0.0f) if(t1<=0.0f) t1=t; else t2=t;
  t  = IntFace(Org, Ray, 2); if(t>0.0f) if(t1<=0.0f) t1=t; else t2=t;
  t  = IntFace(Org, Ray, 3); if(t>0.0f) if(t1<=0.0f) t1=t; else t2=t;
  t  = IntFace(Org, Ray, 4); if(t>0.0f) if(t1<=0.0f) t1=t; else t2=t;
  t  = IntFace(Org, Ray, 5); if(t>0.0f) if(t1<=0.0f) t1=t; else t2=t;
  CInt.t=min(t1,t2); vector D=Org+CInt.t*Ray; CInt.IP=D*TM;
  if((fabs(D.y)>=fabs(D.x)) && (fabs(D.y)>=fabs(D.z))){
	CInt.N = (D.y>0.0f)? vector(0.0f, 1.0f, 0.0f) : vector(0.0f, -1.0f, 0.0f);
  } else {
    if((fabs(D.x)>=fabs(D.y)) && (fabs(D.x)>=fabs(D.z))){
	  CInt.N = (D.x>0.0f)? vector(1.0f, 0.0f, 0.0f) : vector(-1.0f, 0.0f,  0.0f);
    } else {
	  CInt.N = (D.z>0.0f)? vector(0.0f, 0.0f, 1.0f) : vector( 0.0f, 0.0f, -1.0f);
    }
  }
  CInt.N = unit(CInt.N*NM);
  return CInt.t;
}*/

// Extents ---------------------------------------------------------

void Cube::WorldExtents(vector & min, vector & max)
{
  vector mn=vector(-0.5f, -0.5f, -0.5f);
  vector mx=vector( 0.5f,  0.5f,  0.5f);
  CStretch(min, max, mn, mx);
}

// Points ----------------------------------------------------------

vector Cube::RndPnt (void){
  int side = (int)(rnd()*6.0f);
  switch(side) {
    case 0:
      return vector((float)rnd()-0.5f, (float)rnd()-0.5f,              0.5f)*TM;
    case 1:
      return vector((float)rnd()-0.5f, (float)rnd()-0.5f,             -0.5f)*TM;
    case 2:
      return vector(             0.5f, (float)rnd()-0.5f, (float)rnd()-0.5f)*TM;
    case 3:
      return vector(            -0.5f, (float)rnd()-0.5f, (float)rnd()-0.5f)*TM;
    case 4:
      return vector((float)rnd()-0.5f,              0.5f, (float)rnd()-0.5f)*TM;
    case 5:
      return vector((float)rnd()-0.5f,             -0.5f, (float)rnd()-0.5f)*TM;
  }
  return vector(0.0f, 0.0f, 0.0f);
}

vector Cube::PPoint (float u, float v){ return vector(0.0f, 0.0f, 0.0f); }

// Normals ---------------------------------------------------------

vector Cube::PNormal(float u, float v){ return vector(0.0f, 0.0f, 1.0f); }

vector Cube::VNormal(vector p) {
  vector D=p*Tb-vector(0.5f, 0.5f, 0.5f);
  if((fabs(D.y)>=fabs(D.x)) && (fabs(D.y)>=fabs(D.z))){
	return unit((D.y>0.0f)? vector(0.0f, 1.0f, 0.0f)*NM : vector(0.0f, -1.0f, 0.0f)*NM);
  } else {
    if((fabs(D.x)>=fabs(D.y)) && (fabs(D.x)>=fabs(D.z))){
	  return unit((D.x>0.0f)? vector(1.0f, 0.0f, 0.0f)*NM : vector(-1.0f, 0.0f,  0.0f)*NM);
    } else {
	  return unit((D.z>0.0f)? vector(0.0f, 0.0f, 1.0f)*NM : vector( 0.0f, 0.0f, -1.0f)*NM);
    }
  }
}


// Cylinder Primitive for VModel & WinOSi
// --------------------------------------
// 09.06.1999               Michael Granz

// Parsing ---------------------------------------------------------

extern void  GetToken (char *a, CFile *file);
extern float ReadAngle(char *a);

int Cylinder::ParseToken(char *a, CFile *file)
{
  if(!stricmp(a,"Angle")){
    GetToken(a, file); angle = ReadAngle(a);
	return 0;
  }
  if(!stricmp(a,"r_top")){
    GetToken(a, file); r_top = (float)atof(a);
	return 0;
  }
  return 1;
}

// Extents ---------------------------------------------------------

void Cylinder::WorldExtents(vector & min, vector & max)
{
  vector mn=vector(-1.0f, -1.0f, 0.0f);
  vector mx=vector( 1.0f,  1.0f, 1.0f);
  CStretch(min, max, mn, mx);
}

// Points ----------------------------------------------------------

vector Cylinder::RndPnt (void)
{
  double b = 6.2831853*rnd();
  return vector((float)cos(b), (float)rnd(), (float)sin(b))*TM;
}

vector Cylinder::PPoint (float u, float v){ return vector((u*r_top+(1.0f-u))*(float)cos(v), (u*r_top+(1.0f-u))*(float)sin(v), u); }

// Normals ---------------------------------------------------------

vector Cylinder::PNormal(float u, float v)
{
  return (flags & SURF_INVERSE)? -vector((float)cos(v), (float)sin(v), 1.0f-r_top ) : vector((float)cos(v), (float)sin(v), 1.0f-r_top );
}

vector Cylinder::VNormal(vector p)
{
  vector P=p*Tb;
  return (flags & SURF_INVERSE)? -unit(vector(P.x, 0.0f, P.z)*NM) : unit(vector(P.x, 0.0f, P.z)*NM);
}

// Ring Primitive for VModel & WinOSi
// ----------------------------------
// 09.06.1999           Michael Granz


// Parsing ---------------------------------------------------------

extern void  GetToken (char *a, CFile *file);
extern float ReadAngle(char *a);

int Ring::ParseToken(char *a, CFile *file)
{
  if(!stricmp(a,"Angle")){
    GetToken(a, file); angle = ReadAngle(a);
	return 0;
  }
  if(!stricmp(a,"Ri")){
    GetToken(a, file); r_i = (float)atof(a);
	return 0;
  }
  return 1;
}

// Extents ---------------------------------------------------------

void Ring::WorldExtents(vector & min, vector & max)
{
  vector mn=vector(-1.0f, -1.0f, 0.0f);
  vector mx=vector( 1.0f,  1.0f, 0.0f);
  CStretch(min, max, mn, mx);
}

// Points ----------------------------------------------------------

vector Ring::RndPnt (void)
{
  //double b = TwoPi*rnd(); double a=ri+(ra-ri)*rnd();
  //return vector(a*cos(b), 0.0f, a*sin(b))*TM;
  return vector(0.0f, 0.0f, 0.0f);
}

vector Ring::PPoint (float u, float v){ return vector(u*(float)cos(v), u*(float)sin(v), 0.0f); }

// Normals ---------------------------------------------------------

vector Ring::PNormal(float u, float v){ return vector(0.0f, 0.0f, 1.0f); }

vector Ring::VNormal(vector p)        { return vector(0.0f, 0.0f, 1.0f); }

// Sphere Primitive for VModel & WinOSi
// ------------------------------------
// 09.06.1999             Michael Granz


// Parsing ---------------------------------------------------------

extern void  GetToken (char *a, CFile *file);
extern float ReadAngle(char *a);

int Sphere::ParseToken(char *a, CFile *file)
{
  if(!stricmp(a,"Angle")){
    GetToken(a, file); vangle = ReadAngle(a);
	return 0;
  }
  if(!stricmp(a,"Start")){
    GetToken(a, file); ustart = (float)atof(a);
    if(!vangle) vangle = 6.2831853F;
	return 0;
  }
  if(!stricmp(a,"Stop" )){
    GetToken(a, file); ustop  = (float)atof(a);
    if(!vangle) vangle = 6.2831853F;
	return 0;
  }
  return 1;
}

// Extents ---------------------------------------------------------

void Sphere::WorldExtents(vector & min, vector & max)
{
  vector mn=vector(-1.0f, -1.0f, -1.0f);
  vector mx=vector( 1.0f,  1.0f,  1.0f);
  CStretch(min, max, mn, mx);
}

// Points ----------------------------------------------------------

vector Sphere::RndPnt (void){ return (vangle? rrdir(vangle,ustart,ustop) : rnddir())*TM; }

vector Sphere::PPoint (float u, float v){ return vector((float)(cos(v)*cos(u)), (float)(sin(v)*cos(u)), (float)sin(u)); }

// Normals ---------------------------------------------------------

vector Sphere::PNormal(float u, float v){ return vector((float)(cos(v)*cos(u)), (float)(sin(v)*cos(u)), (float)sin(u)); }

vector Sphere::VNormal(vector p) { return (flags & SURF_INVERSE)? -unit((p*Tb)*NM) : unit((p*Tb)*NM); }

// Torus Primitive for VModel & WinOSi
// -----------------------------------
// 09.06.1999            Michael Granz


// Parsing ---------------------------------------------------------

extern void  GetToken (char *a, CFile *file);
extern float ReadAngle(char *a);

int Torus::ParseToken(char *a, CFile *file)
{
  if(!stricmp(a,"Angle")){
    GetToken(a, file); vangle = ReadAngle(a);
	return 0;
  }
  if(!stricmp(a,"Start")){
    GetToken(a, file); ustart = (float)atof(a);
    if(!vangle) vangle = 6.2831853F;
	return 0;
  }
  if(!stricmp(a,"Stop" )){
    GetToken(a, file); ustop  = (float)atof(a);
    if(!vangle) vangle = 6.2831853F;
	return 0;
  }
  if(!stricmp(a,"r1")){
    GetToken(a, file); R1 = (float)atof(a);
	return 0;
  }
  if(!stricmp(a,"r2" )){
    GetToken(a, file); R2 = (float)atof(a);
	return 0;
  }
  return 1;
}

// Extents ---------------------------------------------------------

void Torus::WorldExtents(vector & min, vector & max)
{
  vector mn=vector(-(R1+R2), -(R1+R2), -R2);
  vector mx=vector(  R1+R2 ,   R1+R2 ,  R2);
  CStretch(min, max, mn, mx);
}

// Points ----------------------------------------------------------

vector Torus::RndPnt(void){ return vector(0.0f, 0.0f, 0.0f); }

vector Torus::PPoint(float u, float v){ return vector((float)((R1+R2*cos(u))*cos(v)), (float)((R1+R2*cos(u))*sin(v)), R2*(float)sin(u)); }

// Normals ---------------------------------------------------------

vector Torus::PNormal(float u, float v){ return vector((float)(R2*cos(v)*cos(u)), (float)(R2*sin(v)*cos(u)), (float)(R2*sin(u))); }

vector Torus::VNormal(vector p){ return unit(p); }

// Paraboloid Primitive for VModel & WinOSi
// ----------------------------------------
// 09.06.1999                 Michael Granz


// Parsing ---------------------------------------------------------

extern void  GetToken (char *a, CFile *file);
extern float ReadAngle(char *a);

int Paraboloid::ParseToken(char *a, CFile *file)
{
  if(!stricmp(a,"Angle")){
    GetToken(a, file); angle = ReadAngle(a);
	return 0;
  }
  if(!stricmp(a,"Height")){
    GetToken(a, file); height = (float)atof(a);
	return 0;
  }
  return 1;
}

// Extents ---------------------------------------------------------

void Paraboloid::WorldExtents(vector & min, vector & max)
{
  vector mn=vector(-1.0f, -1.0f,   0.0f);
  vector mx=vector( 1.0f,  1.0f, height);
  CStretch(min, max, mn, mx);
}

// Points ----------------------------------------------------------

vector Paraboloid::RndPnt (void){ return vector(0.0f, 0.0f, 0.0f); }

vector Paraboloid::PPoint (float u, float v){ return u * vector((float)cos(v), (float)sin(v), u); }

// Normals ---------------------------------------------------------

vector Paraboloid::PNormal(float u, float v){ return vector(2.0f*u*(float)cos(v), 2.0f*u*(float)sin(v), -1.0f); }

vector Paraboloid::VNormal(vector p){ return unit(p); }
