// winosiclient.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <time.h>
#include "string.h"

#include "general.h"
#include "Primitives.h"
#include "resource.h"
#include "RaVi.h"
#include "winosi.h"
#include "OCTree.h"


#include "WinOSIDoc.h"
#include "winsock.H"
#include <time.h>
#include <stdlib.h>
        
//#define profiling

#define HBSize 1000

typedef struct Lite  *LitePtr;

struct Lite {
  LitePtr nxt;
  RV_PrP  obj;
  float   pti;
  float   lar;
};


struct WSAData wsd;

char*     host; 
int       XRes = 320;
int       YRes = 240;
HANDLE    die;
int               SendBuffer=0;
float     pixelsize;

float     RelExp = 0.15f;
double    Gamma  = 1.40f;
int		  antialias=0;
int       HitBuffers     = 200;
int       DiffDepth      =   1;
int       SpecLightDepth =   1;
int       SpecViewDepth  =   1;
int       StS_Light      =   1;
int       StS_Diff       =   1;
int       StS_Sky        =   1;
float     GlobalIOR      = 1.0f;
float     PixelRadius    = 1.4142f;
float     RNDPIXELSIZE   = 0;

RGB_Dbl   *accu = NULL; // accumulation buffer

struct RGB_D{float R,G,B,D;};
struct netrgb {
        int x,y,n;
        RGB_D data[100];
};

struct netrgb   netacu; // accumulation buffer

OCTree    SHTree;       // Main Scene and HitBuffer Oct-tree
LitePtr   LiteRoot=NULL;
HtPPtr   *HBuffer=NULL;
int       HBi,HBp;
const  float  ray_thresh3=0.003f;
const  float  ray_thresh=0.001f;

double    fc = 3.0e10;

extern   long int  sSLit;
extern RGB_Color mWhite;
extern RGB_Color mBlack;

__int64  sRays=0,sHits=0;

unsigned long int  sRuns,Hits,nn,Passes=0;
unsigned long int  pRays,pHits;
unsigned long int  sMBa=0,sMBr=0,sMGl;
unsigned long int  sMTh=0,sMTo=0;
double             sOut=0.0,pIn,sIn=0.0;
double             sCtr,sDif;

time_t    sRTime;
time_t    RTCurr;
time_t    TStart;

BOOL      Stop = TRUE;


float wlcoff(float cR, float cG, float cB, float v)
{
  float f;
  if(v>380.0){
	if(v>410.0){
	  if(v>470.0){
	    if(v>500.0){
	      if(v>530.5){
	        if(v>590.0){
	          if(v>660.0){
	            if(v<780.0){
				  f = cR*((780.0f-v)/(780.0f-660.0f));
				}
			  } else {
				f = max(cR,cG*((660.0f-v)/(660.0f-590.0f)));
			  }
			} else {
			  f = max(cG,cR*((v-530.0f)/(590.0f-530.0f)));
			}
		  } else {
			f = max(cG,cB*((530.0f-v)/(530.0f-500.0f)));
		  }
		} else {
		  f = max(cB,cG*((v-470.0f)/(500.0f-470.0f)));
		}
  	  } else {
	    f = max(cB,cR*((470.0f-v)/(470.0f-410.0f)));
	  }
	} else {
	  f = max(cR*((v-380.0f)/(410.0f-380.0f)),cB*((v-380.0f)/(410.0f-380.0f)));
	}
  }
  return f;
}

RGB_Color WL2RGB(float v)
{
  RGB_Color Color;
  Color.R = wlcoff(0.68292f, 0.0f, 0.0f, v);
  Color.G = wlcoff(0.0f, 1.00000f, 0.0f, v);
  Color.B = wlcoff(0.0f, 0.0f, 1.16667f, v);
  return Color;
}

float new_w;
int new_wctr=0;
RGB_Color new_wcolor;
void newwavelen(void)
{
        new_w=380+(float)rnd()*400;
        new_wcolor=WL2RGB(new_w);
        new_wctr=250;
}

float R_fnf(float n1, float n2, double ce1);

/*

 When Photon meets surface, this function called.
 This function can also reflect the photon as diffuse or 
 specular.

*/
RGB_Color PutPhoton(RV_PrP OrgObj, MatPtr mat, vector *Org, vector *Ray, IntPar IntP, RGB_Color em, float dist, int level,float w)
{
  if((HBi>=HitBuffers)) return mBlack;
  GetIPN(Org, Ray, &IntP); 
  float ca = IntP.N % *Ray;
  MatPtr m = IntP.p->Mat; 
//  if(m->Texture) GetTXY(&IntP);
  if (level==0) pHits++;
  RGB_Color v1,val;

  if (mat->Absorption.G < 0.0f) v1=em;  else	  v1=mat->Thru(Org, &IntP.IP) *em;
  if((m->Specularity > 0.99) || (m->Reflection.R < 0.0f)) val=mBlack; else val = v1 * m->Diff(IntP.x, IntP.y);

  if(val.R3()>0.0f) {
		HtPPtr hp = HBuffer[HBi]+HBp;
		HBp++; 
        if(HBp>=HBSize)
        { 
          HBi++; 
          HBp=0;
//		  printf("1000 Photon\n",val.R,val.G);
        }
        hp->next  = NULL;
        hp->obj   = IntP.p;
        hp->pos   = IntP.IP;
        hp->N     = (ca)>0.0? -IntP.N : IntP.N;
        hp->side  = (ca)>0.0?       0 :      1;
        hp->val   = val;
        SHTree.PutIn(hp);
  }
  // distribute diffuse reflected light
  if((level<DiffDepth) && (val.R3() >= ray_thresh3)) {
        vector OutDir;
		if(StS_Diff){
				OutDir=crndhdir(IntP.N);
				RayTrace(IntP.p, mat, &(IntP.IP), &OutDir, val,0.0f, &PutPhoton, level+1, w);
		} else {
				OutDir= rndhdir(IntP.N);
				RayTrace(IntP.p, mat, &(IntP.IP), &OutDir, (float)(OutDir%IntP.N)*val, 0.0f, &PutPhoton, level+1, w);
		}
  }
  // specular reflection/refraction
  if((level<SpecLightDepth) && (m->Specularity>ray_thresh)){
    float  spc = 0.0f, trn=0.0f;
        float  ca  = IntP.N % *Ray;
        vector OutDir;

        if(m->Transmission.R < 0.0f){
          // fresnel reflection?
          float n1,n2;
          if(ca<0.0f){
            n1=mat->IOR(); 
			n2=m->IOR();
          } else {
			n1=m  ->IOR(); 
			n2=RV_Environment.IOR();
          }
          spc = m->Specularity * R_fnf(n1,n2,ca); 
		  trn = m->Specularity-spc;
        } else {
          // simple specular reflection/refraction?
          if((m->Specularity > ray_thresh) && (m->type!=Shader_Phong)){
            spc = m->Specularity * ((m->Reflection.G < 0.0f)? m->Reflection.R : m->Reflection.R2());
        trn = m->Transmission.R;
          }
        }

        // distribute specular reflected light
        if(v1.R3()*spc > ray_thresh3) {
          // mirror direction
          OutDir = -unit(2.0f * ca * IntP.N - *Ray); 
          RayTrace(IntP.p, &RV_Environment, &(IntP.IP), &OutDir, spc*v1*m->Reflection, 0.0f, &PutPhoton, level+1, w);
        }
    // distribute transmitted (refracted) light
        if(v1.R3()*trn > ray_thresh3) {
                if ((w==0) && (mat->IOR_offset>=0.0f)){
                        if (new_wctr ==0) newwavelen();
                        new_wctr--;
                        w=new_w;
                        v1=new_wcolor;
                }
          if(ca<0.0f){
            OutDir=refract(*Ray,  IntP.N, mat->IOR(w),             m->IOR(w));
            RayTrace(IntP.p, m , &(IntP.IP), &OutDir, trn*v1, 0.0f, &PutPhoton, level+1, w);
          } else {
            OutDir=refract(*Ray, -IntP.N, mat->IOR(w), RV_Environment.IOR(w));
            RayTrace(IntP.p, ((OutDir % IntP.N)<0.0f)? m : &(RV_Environment), &(IntP.IP), &OutDir, trn*v1, 0.0f, &PutPhoton, level+1, w);
          }
        }
  }
  
  return mBlack;
}

int renderlight;
vector lasthit;
float lastdist;	

vector rnddirA(vector N,float spc)
{
  float cos_a = 1-(float)sqrt(rnd())*spc;
  float sin_a = sqrtf(1.0f - cos_a * cos_a);
  float     b = TwoPi*(float)rnd();
  vector    u = XfromZ(N);
  return unit(cos_a*N + sin_a*cosf(b)*u - sin_a*sinf(b)*(N*u));
}

RGB_Color GetDiffuse(RV_PrP OrgObj, MatPtr mat, vector *Org, vector *Ray, IntPar IntP, RGB_Color em, float dist, int level,float w)
{
  GetIPN(Org, Ray, &IntP);
  RGB_Color col; 
  float ca = IntP.N % *Ray; 
  float dt=(float)distance(*Org, IntP.IP); 
  MatPtr m = IntP.p->Mat;
  lasthit.x = IntP.IP.x; 
  lasthit.y = IntP.IP.y; 
  lasthit.z = IntP.IP.z; 
  if (lastdist<0) lastdist=dt;
  float d=(dist+dt)*pixelsize;
  col = em*SHTree.GetVal(IntP.IP, d, sqr(d), ca>0.0f?  0 : 1);
  if(renderlight && (m->Emission.R2()>0.0f)){
    LitePtr l=LiteRoot; while(l && (l->obj != IntP.p)) l=l->nxt;
    col += (pRays/l->lar)*m->Emission;
//      col += m->Emission;
  }

  // specular reflection/refraction
  if((level<SpecViewDepth) && (m->Specularity>ray_thresh)){
    float  spc = 0.0f, trn=0.0f;
        vector OutDir;

        if(m->Transmission.R < 0.0f){
          // fresnel reflection?
          float n1,n2;
          if(ca<0.0f){
            n1=mat->IOR(); n2=            m->IOR();
          } else {
        n1=m  ->IOR(); n2=RV_Environment.IOR();
          }
          spc = m->Specularity * R_fnf(n1,n2,ca); trn = m->Specularity-spc;
        } else {
          // simple specular reflection/refraction?
          if((m->Specularity > ray_thresh) && (m->type!=Shader_Phong)){
            spc = m->Specularity * ((m->Reflection.G < 0.0f)? m->Reflection.R : m->Reflection.R2());
			trn = m->Transmission.R2();
          }
        }

        // collect specular reflected light
        if(spc > ray_thresh) {
          // mirror direction
          OutDir = -unit(2.0f * ca * IntP.N - *Ray); 
		  if (m->Blur==0.0f) 
			col += (spc * RayTrace(IntP.p, &RV_Environment, &(IntP.IP), &OutDir, m->Reflection, dist+dt, &GetDiffuse, level+1, 0.0f));
		  else {
			for (int j=0;j<3;j++){
				vector OutDirx = rnddirA(OutDir,m->Blur);
				col += 0.33*(spc * RayTrace(IntP.p, &RV_Environment, &(IntP.IP), &OutDirx, m->Reflection, dist+dt, &GetDiffuse, level+1, 0.0f));
			}
		  }
        }
    // collect transmitted (refracted) light
        if(trn > ray_thresh) {
          if(ca<0.0f){
            OutDir=refract(*Ray,  IntP.N, mat->IOR(),             m->IOR());
            col += trn * RayTrace(IntP.p,  m  , &(IntP.IP), &OutDir, mWhite, dist+dt, &GetDiffuse, level+1, 0);
          } else {
            OutDir=refract(*Ray, -IntP.N, mat->IOR(), RV_Environment.IOR());
            col += trn * RayTrace(IntP.p, ((OutDir % IntP.N)<0.0f)? m : &(RV_Environment), &(IntP.IP), &OutDir, mWhite, dist+dt, &GetDiffuse, level+1, 0);
          }
        }
  }
  // absorbtion
  if (mat->Absorption.G < 0.0f) return col;
  return mat->Thru(dt)*col;
}

RGB_Color CallGetDiffuse(vector *Org, vector *Ray, IntPar IntP, MatPtr mat, int level,float w)
{
  return GetDiffuse(NULL, mat, Org, Ray, IntP, mWhite, 0.0f, level,w);
}

void OnRenderStart()
{
  RGB_Dbl *bptr; int x,y; 
  nn=0; 
  sRuns=0; 
  sRays=0; 
  sHits=0; 
  sRTime=0; 
  sIn=0;
  
  
  
  // allocate and clear accumulation buffer
  accu=new RGB_Dbl[XRes*YRes]; 
  sMBa=XRes*YRes*sizeof(RGB_Dbl);
  for(y=0; y<YRes; y++){
    bptr=accu+(y*XRes);
    for(x=0;x<XRes;x++){
      bptr[x].R=0.0;
      bptr[x].G=0.0;
      bptr[x].B=0.0;
    }
  }

  Hits=0;
  sMBr=XRes*YRes*sizeof(RGB_Color);


}

float CalcArea(RV_PrP p){
  if(p->type == 0){
        return Betrag(((RV_TriPara *)p)->edg1 * ((RV_TriPara *)p)->edg2 * 0.5f);
  } else if(p->type == 1){
        return Betrag(((RV_TriPara *)p)->edg1 * ((RV_TriPara *)p)->edg2       );
  } else if(p->type == 2){
    return ((RV_SimpleSphere *)p)->r2*4*Pi;
  }
  return 1.0f;
}

// calculate total global light emission of tree content
float CalcGLE(BSPplane *tree)
{
  if(tree->axis == 0){
    float LLE=0.0f; PrLP p = (PrLP)tree->left;
    while(p){
          if(p->Prim->Mat->Emission.R4() > 0.0f){
            if(p->Prim->lastframe != 111){
                  LLE += p->Prim->Mat->Emission.R4(); sSLit++;
                  p->Prim->lastframe=111;
                }
          }
      p=p->next;
        }
        return LLE;
  } else {
        return CalcGLE(tree->left) + CalcGLE(tree->rigt);
  }
}

// create light-emitter-list with statistically distibuted priorities
void CreateLL(BSPplane *tree, float & cpti, float GLI)
{
  if(tree->axis == 0){
    PrLP p = (PrLP)tree->left;
    while(p){
          if(p->Prim->Mat->Emission.R4() > 0.0f){
            if(p->Prim->lastframe != 112){
          LitePtr l      = new(Lite);
                      l->nxt = LiteRoot; LiteRoot=l;
                      l->obj = p->Prim;
                      l->pti = cpti; cpti -= p->Prim->Mat->Emission.R4() / GLI;
                                  l->lar = CalcArea(p->Prim);
                  p->Prim->lastframe=112;
                }
          }
      p=p->next;
        }
  } else {
        CreateLL(tree->left, cpti, GLI);
        CreateLL(tree->rigt, cpti, GLI);
  }
}

void checkdie()
{
        if (WaitForSingleObject(die,0)==WAIT_OBJECT_0) {Stop=TRUE;}
}
vector makevec(vector N,float a,float b)
{
  float cos_a = cosf(a);
  float sin_a = sinf(a);
  vector    u = XfromZ(N);
  return unit(cos_a*N + sin_a*cosf(b)*u - sin_a*sinf(b)*(N*u));
}

void OnRenderContinue() 
{
  RGB_Dbl   *acuptr;
  RGB_Dbl   *acuptr2;
  float*     Dbuffer;
  int        x,y;
  vector     Pym,LPos,LNrm,LDir;
  RV_PrP     LightObj;
  RGB_Color  val;
  //HtPPtr     hp;
  //FILE     *logfile;
  Dbuffer=new float[XRes*YRes];
  if(!accu) OnRenderStart();

  vector N = unit(Document->VMF.CV.Target - Document->VMF.CV.Location);
  vector V = unit(Document->VMF.CV.Up-(Document->VMF.CV.Up%N)*N);
  vector U = N*V;

  float b     = 0.5f*Document->VMF.CV.h;
  float bx    = XRes<YRes? b : b*((float)XRes/(float)YRes)    ;
  float by    = XRes<YRes?     b*((float)YRes/(float)XRes) : b;

  pixelsize = (float)(bx / (double)XRes) * PixelRadius;
  
  vector VPorg = Document->VMF.CV.Location + N - bx*U - by*V;

  // Seed the random-number generator with current time so that
  // the numbers will be different every time we run.
  //srand((unsigned)time(NULL)); seed = (double)(rand()&0x7FFF)/(double)0x7FFF;
  //extern long int rngh,rng; rng=time(NULL);
  rndinit(time(NULL));

  // allocate hit-buffers
  sMTh=0;
  HBuffer=(HtPPtr *)new HtPPtr[HitBuffers]; 
  sMTh+=HitBuffers*sizeof(HtPPtr);
  for(y=0; y<HitBuffers; y++){
    HBuffer[y]=(HtPPtr)new(HitPoint[HBSize]); sMTh+=HBSize*sizeof(HitPoint);
  }

  RV_SceneTree=Document->BSPtree; RV_Environment=Document->VMF.Environment;

  float cpti=1.0f; 
  Stop = FALSE; 
  // calculate total global light emission
  sSLit=0; float GLI = CalcGLE(Document->BSPtree);
  PrLP p = Document->Invisibles;
  while(p){
        if(p->Prim->Mat->Emission.R4() > 0.0f){ GLI += p->Prim->Mat->Emission.R4(); sSLit++; }
    p=p->next;
  }
  // create light-emittor-list with statistically distibuted priorities
  CreateLL(Document->BSPtree, cpti, GLI); p = Document->Invisibles;;
  while(p){
        if(p->Prim->Mat->Emission.R4() > 0.0f){
        LitePtr l      = new(Lite);
                  l->nxt = LiteRoot; LiteRoot=l;
                  l->obj = p->Prim;
                  l->pti = cpti; cpti -= p->Prim->Mat->Emission.R4() / GLI;
              l->lar = CalcArea(p->Prim);
			  LightObj=l->obj;
//			  LightObj->Mat->Fix();
        }
    p=p->next;
  }


  time(&TStart);

  new_wctr=0;
  float opx=pixelsize;
//  Passes=10;
  while(!Stop){
    // collect light hits
//	    printf("Photon Tracing.\n");
		pRays=0; pHits=0; pIn=0.0; HBi=0; HBp=0; SHTree.Kill(); sMTo=0;

		while((HBi<HitBuffers) && !Stop){
			cpti=(float)rnd(); 
			LitePtr l=LiteRoot; 
			while(cpti > l->pti) l=l->nxt; 
			LightObj = l->obj;
			LPos = RV_RndPt(LightObj);
			val  = LightObj->Mat->Emission;
			for (int it=0;(it<10000) && (HBi<HitBuffers);it++){
				if(StS_Light){
					LDir = crndhdir(LNrm=RV_PtNrm(LightObj,LPos));
				} else {
					LDir =  rndhdir(LNrm=RV_PtNrm(LightObj,LPos));
					val  = LNrm%LDir*LightObj->Mat->Emission;
				}
				RayTrace(LightObj, &(Document->VMF.Environment), &LPos, &LDir, val, 0.0f, &PutPhoton, 0, 0);
				pRays++;
			}
		}
        
		checkdie();
        // trace scene
		if(!Stop){
			RV_Shader = &CallGetDiffuse; 
			*RV_CamPtr = Document->VMF.CV.Location;
			memset(Dbuffer,0,XRes*YRes*sizeof(float));
//			printf("Eye Tracing.\n");
/*
// Trace Small one
				renderlight=0;
				float ite=0.3;
				for(y=0; (y<YRes) && !Stop; y=y+2){
					float ry = 1.1f*((float)rnd()-0.5f);
					acuptr=accu+(y*XRes);
					acuptr2=accu+((y+1)*XRes);
					Pym = VPorg + ((float)y+ry)/(float)YRes*2.0f*by*V - Document->VMF.CV.Location;
					for(x=0; x<XRes; x=x+2){
						float rx = 1.1f*((float)rnd()-0.5f);
						pixelsize=((float)rnd()*RNDPIXELSIZE+1)*opx;
						lastdist=-1;
						RGB_Color rrc= ite*RayTrace0(unit(Pym + ((float)x+rx)*(2.0f/(float)XRes*bx*U)));
						acuptr[x].R+=rrc.R;
						acuptr[x].G+=rrc.G;
						acuptr[x].B+=rrc.B;
						acuptr[x+1].R+=rrc.R;
						acuptr[x+1].G+=rrc.G;
						acuptr[x+1].B+=rrc.B;
						acuptr2[x].R+=rrc.R;
						acuptr2[x].G+=rrc.G;
						acuptr2[x].B+=rrc.B;
						acuptr2[x+1].R+=rrc.R;
						acuptr2[x+1].G+=rrc.G;
						acuptr2[x+1].B+=rrc.B;
					}
//					memcpy(acuptr2,acuptr,XRes*sizeof(RGB_Dbl));
					checkdie();
				}
*/
// Trace Big one
				renderlight=1;
				for (int i=0;i<=antialias;i++){
				float ry = 1.1f*((float)rnd()-0.5f);
				float rx = 1.1f*((float)rnd()-0.5f);
				for(y=0; (y<YRes) && !Stop; y++){
					acuptr=accu+(y*XRes);
					float* dptr=Dbuffer+(y*XRes); 
					Pym = VPorg + ((float)y+ry)/(float)YRes*2.0f*by*V - Document->VMF.CV.Location;
					for(x=0; x<XRes; x++){
						pixelsize=((float)rnd()*RNDPIXELSIZE+1)*opx;
						lastdist=-1;
						RGB_Color rrc= RayTrace0(unit(Pym + ((float)x+rx)*(2.0f/(float)XRes*bx*U)));
				 		acuptr[x].R+=rrc.R;
						acuptr[x].G+=rrc.G;
						acuptr[x].B+=rrc.B;
						dptr[x] += lastdist;
					}
					checkdie();
				}
				}
		}
		pixelsize=opx;
		if(!Stop){
			int nsock;
            struct sockaddr_in addr;
            nsock=socket(AF_INET,SOCK_STREAM,0);
            addr.sin_family=AF_INET;        
            addr.sin_port=htons(2500);
            addr.sin_addr.S_un.S_addr=inet_addr(host);
            int err=connect(nsock,(sockaddr*)&addr,sizeof(addr));
        
          // add render buffer to accumulation buffer
            for(y=0; y<YRes; y++){
				acuptr=accu+(y*XRes);
				float* dptr=Dbuffer+(y*XRes); 
				netacu.y=y;
				RGB_D* netacupix=netacu.data;
				int lx=0;
				for(x=0;x<XRes;x++){
					netacupix->R = (float)acuptr[x].R;
					netacupix->G = (float)acuptr[x].G;
					netacupix->B = (float)acuptr[x].B;
					netacupix->D = dptr[x];
                    netacupix++;
                    if (((x==XRes-1) || (x-lx>=19))) {
					    netacu.x=lx;
                        netacu.n=x-lx;
						if (!err) send(nsock,(char *)&netacu,12+20*sizeof(RGB_D),0);
						lx=x;
						netacupix=netacu.data;
                    }
				}
			}
            closesocket(nsock);
		}
        nn++; sRuns=nn;
        sRays+=pRays; sHits+=pHits; sIn+=pIn;
#ifdef profiling
        if(Passes && (nn>=Passes)) Stop=TRUE;
        RTCurr=time(NULL)-TStart;
        if((sRTime+RTCurr)>0){
			char buffer[20];
            printf("PASS %d\nRays: %d/s\n",Passes,sRays/(sRTime+RTCurr));
            printf("Rays: %d/s\n",sHits/(sRTime+RTCurr));
        }
#endif  
  }
  sRTime+=RTCurr; RTCurr=0;

  // free Oct-tree
  SHTree.Kill(); sMTo=0;

  // free hit-buffers
  for(y=0; y<HitBuffers; y++){
    if(HBuffer[y]) delete(HBuffer[y]);
  }
  if(HBuffer) delete(HBuffer); sMTh=0;

  // free light-list
  LitePtr lp; while(LiteRoot){ lp=LiteRoot->nxt; delete(LiteRoot); LiteRoot=lp; }
  sMBr=0;
  
}

int __cdecl main(int argc, char* argv[])
{
        if (!strcmp(argv[1],"temp.vmd")) FreeConsole();
	    WSAStartup(0x101,&wsd);
        die=CreateEvent(NULL,FALSE,FALSE,"stoprender");
        CWinOSIDoc Doc;
        Doc.OnFileOpen(argv[1]);
        host=argv[2];
        OnRenderStart();
        OnRenderContinue();
        CloseHandle(die);
        return 0;
}


